<template>
  <div class="p-2">
    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10">
          <el-col :span="1.5">
            <el-button v-has-permi="['setting:carousel:add']" type="primary" plain icon="Plus" @click="handleAdd()">{{
              t('carousel.button.add') }}</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button v-has-permi="['setting:carousel:edit']" type="success" plain :disabled="single" icon="Edit"
              @click="handleUpdate()">{{ t('carousel.button.edit') }}</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button v-has-permi="['setting:carousel:remove']" type="danger" plain :disabled="multiple" icon="Delete"
              @click="handleDelete()">{{ t('carousel.button.delete') }}</el-button>
          </el-col>
          <RightToolbar v-model:show-search="showSearch" :columns="columns" :search="true" @query-table="getList">
          </RightToolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" border :data="carouselList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column :label="t('carousel.table.id')" align="center" prop="id" v-if="true" />
        <el-table-column :label="t('carousel.table.image')" align="center" prop="ossidUrl" width="100">
          <template #default="scope">
            <image-preview :src="scope.row.ossidUrl" :width="50" :height="50" />
          </template>
        </el-table-column>
        <el-table-column :label="t('carousel.table.sort')" align="center" prop="sort" />
        <el-table-column :label="t('carousel.table.note')" align="center" prop="note" />
        <el-table-column :label="t('carousel.table.action')" fixed="right" width="200"
          class-name="small-padding fixed-width">
          <template #default="scope">
            <el-button v-has-permi="['setting:carousel:edit']" type="primary" icon="Edit"
              style="padding: 0 5px; font-size: 10px; height: 24px" @click="handleUpdate(scope.row)">
              {{ t('carousel.button.edit') }}
            </el-button>
            <el-button v-has-permi="['setting:carousel:remove']" type="danger" icon="Delete"
              style="padding: 0 5px; font-size: 10px; height: 24px" @click="handleDelete(scope.row)">
              {{ t('carousel.button.delete') }}
            </el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改轮播图设置对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="carouselFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item :label="t('carousel.form.image')" prop="ossid">
          <image-upload v-model="form.ossid" :limit="1" />
        </el-form-item>
        <el-form-item :label="t('carousel.form.sort')" prop="sort">
          <el-input v-model="form.sort" :placeholder="t('carousel.form.sortPlaceholder')" />
        </el-form-item>
        <el-form-item :label="t('carousel.form.note')" prop="note">
          <el-input v-model="form.note" :placeholder="t('carousel.form.notePlaceholder')" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">{{ t('carousel.button.save')
            }}</el-button>
          <el-button @click="cancel">{{ t('carousel.button.cancel') }}</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Carousel" lang="ts">
import { ref, reactive, onMounted, getCurrentInstance, toRefs } from 'vue';
import { useI18n } from 'vue-i18n';
import { listCarousel, getCarousel, delCarousel, addCarousel, updateCarousel } from '@/api/setting/carousel';
import { CarouselVO, CarouselQuery, CarouselForm } from '@/api/setting/carousel/types';
import { checkPermi } from '@/utils/permission';
import RightToolbar from '@/components/RightToolbar/index.vue';
import { ArrowDown } from '@element-plus/icons-vue';

const { t } = useI18n();

const { proxy } = getCurrentInstance() as ComponentInternalInstance;

// 类型定义
type DialogOption = {
  visible: boolean;
  title: string;
};

type ElFormInstance = any;

type PageData<T, Q> = {
  form: T;
  queryParams: Q;
  rules: any;
};

const carouselList = ref<CarouselVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const showSearch = ref(true);

const carouselFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

// 列显隐信息
const columns = ref([
  { key: 0, label: '序号', visible: true, children: [] },
  { key: 1, label: '图片', visible: true, children: [] },
  { key: 2, label: '排序', visible: true, children: [] },
  { key: 3, label: '备注', visible: true, children: [] },
  { key: 4, label: '操作', visible: true, children: [] }
]);

const initFormData: CarouselForm = {
  id: undefined,
  ossid: undefined,
  sort: undefined,
  note: undefined
};
const data = reactive<PageData<CarouselForm, CarouselQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    params: {}
  },
  rules: {
    id: [{ required: true, message: '序号不能为空', trigger: 'blur' }],
    ossid: [{ required: true, message: '图片不能为空', trigger: 'blur' }],
    sort: [{ required: true, message: '排序不能为空', trigger: 'blur' }]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询轮播图设置列表 */
const getList = async () => {
  loading.value = true;
  const res = await listCarousel(queryParams.value);
  carouselList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  carouselFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: CarouselVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = t('carousel.dialog.add');
};

/** 修改按钮操作 */
const handleUpdate = async (row?: CarouselVO) => {
  reset();
  const _id = row?.id || ids.value[0];
  const res = await getCarousel(_id);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = t('carousel.dialog.edit');
};

/** 提交按钮 */
const submitForm = () => {
  carouselFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateCarousel(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await addCarousel(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess(t('carousel.message.saveSuccess'));
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: CarouselVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm(t('carousel.dialog.confirmDelete', { ids: _ids })).finally(() => (loading.value = false));
  await delCarousel(_ids);
  proxy?.$modal.msgSuccess(t('carousel.message.deleteSuccess'));
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'setting/carousel/export',
    {
      ...queryParams.value
    },
    `carousel_${new Date().getTime()}.xlsx`
  );
};

onMounted(() => {
  getList();
});
</script>
